#! /usr/bin/python

## <filename>
## Copyright (C) 2007 Ivan Uemlianin
## Contact: ivan@llaisdy.com
## 
## This file is part of Trefnydd.
##
## Trefnydd is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## Trefnydd is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with Trefnydd (i.e., doc/gpl.txt); if not, write to the Free Software
## Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
## or see http://www.gnu.org/licenses/gpl.txt


"""
========
trefnydd
========

Package:   trefnydd
Module:    ---
Copyright: 2007 Ivan A. Uemlianin
Contact:   ivan@llaisdy.com
Licence:   GNU GPL (see doc/gpl.txt)

Module
======

"""


# from trefnydd.gui import gui
import os
from pprint import pprint

template = """\
class %s(HTKCommand):
    def __init__(self, debug=False):
        HTKCommand.__init__(self, debug)
        self.name = '%s'
        self.usage = \"\"\"%s\n\n\"\"\"
        self.switch_keys = %s
"""


def parse_htk(cmd):
    stdin, stdout, stderr = os.popen3(cmd)
    usage = stdout.read().strip()
    lines = usage[usage.index('Default\n\n')+9:].split('\n')
    switches = [line.split()[0] for line in lines if line]
    switches = pp_switches(switches)
    #print '** %s\n\n%s' % (cmd, usage)
    #print switches
    print template % (cmd, cmd, usage, switches)

def pp_switches(sw):
    pp = []
    for i in range(0, len(sw), 5):
        pp.append("'%s'" % "', '".join(sw[i:i+5]))
    out = '[%s]' % ',\n                            '.join(pp)
    return out


"""
** HCopy


USAGE: HCopy [options] src [ + src ...] tgt ...

 Option                                       Default

 -a i     Use level i labels                  1
 -e t     End copy at time t                  EOF
 -i mlf   Save labels to mlf s                null
 -l dir   Output target label files to dir    current
 -m t     Set margin of t around x/n segs     0
 -n i [j] Extract i'th [to j'th] label        off
 -s t     Start copy at time t                0
 -t n     Set trace line width to n           70
 -x s [n] Extract [n'th occ of] label  s      off
 -A      Print command line arguments         off
 -C cf   Set config file to cf                default
 -D      Display configuration variables      off
 -F fmt  Set source data format to fmt        as config
 -G fmt  Set source label format to fmt       as config
 -I mlf  Load master label file mlf
 -L dir  Set input label (or net) dir         current
 -O      Set target data format to fmt        as config
 -P      Set target label format to fmt       as config
 -S f    Set script file to f                 none
 -T N    Set trace flags to N                 0
 -V      Print version information            off
 -X ext  Set input label (or net) file ext    lab

"""


def main(cmd):
    parse_htk(cmd)

cmds = ['HBuild',
        'HCompV',
        'HCopy',
        'HDMan',
        'HERest',
        'HHEd',
        'HInit',
        'HLEd',
        'HList',
        'HLMCopy',
        'HLRescore',
        'HLStats',
        'HMMIRest',
        'HParse',
        'HQuant',
        'HRest',
        'HResults',
        'HSGen',
        'HSLab',
        'HSmooth',
        'HVite',
        'LAdapt',
        'LBuild',
        'LFoF',
        'LGCopy',
        'LGList',
        'LGPrep',
        'LLink',
        'LMerge',
        'LNewMap',
        'LNorm',
        'LPlex',
        'LSubset']

# 'Cluster', 

if __name__ == '__main__':
    for cmd in cmds:
        print '#', cmd
        main(cmd)
 
